﻿package uk.org.jwhitham.thumbnail.python {
	
	import flash.net.*;
	import flash.events.*;
	
	public class PythonConnection extends EventDispatcher {
		
		public static const SEND_SUCCESS:String = "sendSucess";
		public static const SEND_FAILED:String = "sendFailed";
		public static const MESSAGE_RECEIVED:String = "messageReceived";
		public static const REMOTE_METHOD_CALLBACK:String = "remoteMethodCallback";
		
		public static const methodNamePrefix:String = "$";
		public static const methodIDPrefix:String = "@";
		public static const remoteCallDelimiter:String = ",";
		public static const messageStartDelimiter:String = "#S#";
		public static const messageEndDelimiter:String = "#E#";
		public static const maxMessageLength:uint = 120; //(probably 127)
		
		protected var receiver_lc:LocalConnection;
		protected var emitter_lc:LocalConnection;
		
		protected var receiverConnectionName:String = "frm";
		protected var emitterConnectionName:String = "t";
		protected var sendingMethodName:String = "swfSays";
		
		protected var lastReceivedMessage:String;
		
		function PythonConnection () {
			this.receiver_lc = new LocalConnection();
			this.receiver_lc.connect(this.receiverConnectionName);
			this.receiver_lc.client = this;
			
			this.emitter_lc = new LocalConnection();
			this.emitter_lc.addEventListener(StatusEvent.STATUS, this.onStatusEvent);
		}
		
		protected function onStatusEvent (e:StatusEvent):void {
			switch (e.level) {
				case "status":
					this.dispatchEvent(new Event(PythonConnection.SEND_SUCCESS));
					break;
				case "error":
					this.dispatchEvent(new Event(PythonConnection.SEND_FAILED));
					break;
			}
		}
		
		public function sendMessage (message:String):void {
			var wrappedMessage:String = PythonConnection.messageStartDelimiter+message+PythonConnection.messageEndDelimiter;
			if (wrappedMessage.length<PythonConnection.maxMessageLength) {
				this.emitter_lc.send(this.emitterConnectionName, this.sendingMethodName, wrappedMessage);
			} else {
				var i:uint = 0;
				var max:uint = wrappedMessage.length;
				while (true) {
					this.emitter_lc.send(this.emitterConnectionName, this.sendingMethodName, wrappedMessage.slice(i, i+PythonConnection.maxMessageLength));
					if (i>max) break;
					i += PythonConnection.maxMessageLength;
				}		  
			}
		}
		public function callRemoteMethod (methodName:String, id:String, ...args:Array):void {
			var sendStr:String = PythonConnection.methodNamePrefix+methodName+PythonConnection.methodIDPrefix+id+PythonConnection.remoteCallDelimiter+args.join(PythonConnection.remoteCallDelimiter);
			this.sendMessage(sendStr);
		}
		
		public function exeSays (message):void {
			if (message.charAt(0) == PythonConnection.methodNamePrefix) {
				var args:Array = message.split(PythonConnection.remoteCallDelimiter);
				var idIndex:int = args[0].lastIndexOf(PythonConnection.methodIDPrefix);
				var method:String = args[0].slice(1, idIndex);
				var id:String = args[0].slice(idIndex+1);
				this.dispatchEvent(new RemoteCallbackEvent(method, id, args[1]));
			} else {
				this.lastReceivedMessage = message;
				this.dispatchEvent(new Event(PythonConnection.MESSAGE_RECEIVED));
			}
		}
		public function getReceivedMessage ():String {
			return this.lastReceivedMessage;
		}
		
		public function setReceiverConnectionName (name:String):void {
			this.receiverConnectionName = name;
		}
		public function setEmitterConnectionName (name:String):void {
			this.emitterConnectionName = name;
		}
	}
}